-- TIC-80 runner for LOVE2D
-- By Cubee

-----------------------------------
---------- Main Function ----------
-----------------------------------

function love_run()
  if TIC~=nil then
    TIC()
    if OVR~=nil then
      OVR()
    end
    return false
  end
----------------------------------
-- Place TIC-80 Code After Here --
----------------------------------

-- title:  TILO demo
-- author: Cubee Games
-- desc:   TIC-80 code runner for LOVE2D
-- script: lua

t=0
x=120
y=0
run=true
pos=0
pt=0
tilo_sc=1

function TIC()

 pt=pos
 if run then
  pos=math.sin(t/50)*128
 end
 if pos<pt then
  run=false
		t=0
 end
	if not run then
	 tilo_sc=t-60
		if tilo_sc<1 then
		 tilo_sc=1
		end
		if tilo_sc>60 then
		 tilo_sc=60
			if not start then
			 t=0
			 sfx(0)
			end
			start=true
		end
	end

	cls(0)
	if not start then
	 spr(1,x-8*tilo_sc+tilo_sc*1.5,y+148-pos/2-8*tilo_sc,14,tilo_sc,0,0,2,2)
  if tilo_sc>=60 then
	 	rect(0,0,240,136,0)
	 end
	else
	 if t==80 then
		 sfx(1)
		end
	 if t>40 and t<60 then
		 cls(14)
		else
		 cls(0)
		end
		if t>20 and t<60 then
	  for i=0,120 do
		  line(i*2,0,i*2,136,6)
			end
		end
		if t>80 then
		 print("TILO",8,8)
			print(" - TIC-80 code runner for LOVE2D",30,8,3)
		end
		if t>120 then
		 print("READY",8,32,3)
		 print("PRESS ESC TO EXIT",8,40,3)
		end
	end
	t=t+1
end


-----------------------------------
-- Place TIC-80 Code Before Here --
-----------------------------------
  if TIC==nil then
    return true -- error if TIC() function does not exist
  end
end




-----------------------------------
---------- Load Function ----------
-----------------------------------

function love.load()
  love.graphics.setDefaultFilter("nearest",nearest,0)

  love_t=0
  love_trace={}
  love_trace_time=0

  -- Create map
  love_map={}
  for mapx=-2,242 do
    love_map[mapx]={}
    for mapy=-2,138 do
      love_map[mapx][mapy]=0
    end
  end

  -- Load spritesheet and separate the tiles
  love_sheet=love.graphics.newImage("sprites.png")
  love_spr_quad={} -- Make matrix
  for w=1,love_sheet:getWidth()/8 do
    love_spr_quad[w] = {} -- Add new rows
    for h=1,love_sheet:getHeight()/8 do
      love_image_quad=love.graphics.newQuad(w*8-8,h*8-8,8,8,love_sheet:getDimensions()) -- Make tiles
      love_spr_quad[w][h]=love_image_quad
    end
  end

  -- Set font
  love_chars=" abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,!?-+/():;%&`'*#=[]\""
  love_font=love.graphics.newImageFont("font.png",love_chars)
  love.graphics.setFont(love_font)

  -- Get screen resolution
  love_aw,love_ah=love.window.getDesktopDimensions()
  --love_aw=240*2
  --love_ah=136*2

  -- Internal Resolution
  love_sw=240
  love_sh=136

  -- Scale to fit screen
  if love_aw/love_ah<love_sw/love_sh then
    love_scale=love_aw/love_sw
  else
    love_scale=love_ah/love_sh
  end

  -- Use integer scaling unless it would result in a scale of 0
  if love_scale>1 then
    love_scale=math.floor(love_scale)
  end

  -- Calculate offset to put image in the middle
  love_wo=(love_aw/love_scale)/2-(love_sw/2)
  love_ho=(love_ah/love_scale)/2-(love_sh/2)

  -- Set screen
  love_icon=love.image.newImageData("icon.png")
  love.window.setMode(love_aw,love_ah)
  love.window.setIcon(love_icon)
  love.window.setTitle("TIC-80 To LOVE2D")

  -- TIC-80 default palette
  love_palette={
    {20,12,28},
    {68,36,52},
    {48,52,109},
    {78,74,78},
    {113,76,48},
    {52,101,36},
    {208,70,72},
    {117,113,97},
    {89,125,206},
    {210,125,44},
    {133,149,161},
    {109,170,44},
    {210,170,153},
    {109,194,202},
    {218,212,94},
    {222,238,214}
  }
end




-----------------------------------
-------- Missing TIC Demo ---------
-----------------------------------

function MISSING_TIC()
  if playing==nil then
    missing_music=love.audio.newSource("demo-resources/music.wav","stream")
    missing_music:setLooping(true)
    playing=true
    love_sfx(missing_music)
  end
  cls(0)
  for ix=-5,5 do
    for iy=-8,8 do
      love_timer=math.tan(time()/3200+ix*16+(iy/2))
      circ_size=math.cos(love_timer)*2.6
      circ(24*love_timer+120,iy*(circ_size*3)+love_sh/2,math.abs(circ_size),math.abs(circ_size)/1.1)
    end
  end
  love_timer=math.tan(time()/800)
  print("TIC() function does not exist!\nPress ESC key to exit.",math.tan(love_t/100)*10+love_sw/2-64,math.tan(love_t/100)*10+love_sh/2-6)
end




-----------------------------------
---------- Draw Function ----------
-----------------------------------

function love.draw()
  love.graphics.scale(love_scale,love_scale)
  love.graphics.translate(love_wo,love_ho)
  error=love_run()
  if error then
    MISSING_TIC()
  end
  love_t=love_t+1
  if love_trace_time>0 then
    for i=1,#love_trace do
      print(love_trace[i],1,1+6*i-6)
    end
    love_trace_time=love_trace_time-1
  end
end




-----------------------------------
--------- LOVE Functions ----------
-----------------------------------

function love.keypressed(k)
  if k=="escape" then
    love.event.quit()
  end
end

function setColour(c)
  if c==nil then
    c=0
  end
  if c>#love_palette-1 then
    c=#love_palette-1
  end
  if c<0 then
    c=0
  end
  c=math.floor(c)
  love.graphics.setColor(love_palette[c+1][1],love_palette[c+1][2],love_palette[c+1][3])
end

-- Play sound
function love_sfx(sound)
  audio_count=love.audio.getSourceCount()
  if audio_count>0 then
    love.audio.stop(sound)
  end
  love.audio.play(sound)
end




-----------------------------------
---------- TIC Functions ----------
-----------------------------------

function trace(text)
  if love_trace[#love_trace]~=text then -- Prevent spamming the same message
    love_trace[#love_trace+1]=text
  end
  if #love_trace>10 then
    table.remove(love_trace,1)
  end
  love_trace_time=60
end

function print(text,x,y,c)
  text=tostring(text)
  if c==nil then
    c=15
  end
  if text~=nil then
    setColour(c)
    love.graphics.printf(text,x,y,240,"left")
  end
  return #text*5
end

function font(text,x,y)
  print(text,x,y)
end

function spr(i,x,y,tr,sc,f,r,w,h)
  i=math.floor(i)
  if tr==nil then
    tr=-1
  end
  if sc==nil then
    sc=1
  end
  if f==nil then
    f=0
  end
  if r==nil then
    r=0
  end
  if w==nil then
    w=1
  end
  if h==nil then
    h=1
  end
  love_spr_y=math.floor(i/16)
  if love_spr_y<0 then
    love_spr_y=0
  end
  love_spr_x=i-(love_spr_y*16)
  for ih=1,h do
    for iw=1,w do
      love_drawable=love_spr_quad[love_spr_x+iw][love_spr_y+ih]
      love.graphics.draw(love_sheet,love_drawable,x+(iw*8-8)*sc,y+(ih*8-8)*sc,0,sc,sc)
    end
  end
  --love.graphics.rectangle("fill",x,y,(w*sc)*8,(h*sc)*8)
end

function cls(c)
  setColour(c)
  love.graphics.rectangle("fill",0,0,love_sw,love_sh)
  love.graphics.setColor(255,255,255)
end

function exit()
  love.event.quit()
end

function btn(b)
  if b~=nil then
    if b==0 then
      button=love.keyboard.isDown("up")
    elseif b==1 then
      button=love.keyboard.isDown("down")
    elseif b==2 then
      button=love.keyboard.isDown("left")
    elseif b==3 then
      button=love.keyboard.isDown("right")
    elseif b==4 then
      button=love.keyboard.isDown("z")
    elseif b==5 then
      button=love.keyboard.isDown("x")
    elseif b==6 then
      button=love.keyboard.isDown("a")
    elseif b==7 then
      button=love.keyboard.isDown("s")
    end
    if button then
      return true
    else
      return false
    end
  else
    return 0
  end
end

function btnp(b)
  return btn(b)
end

function key(b)
  if b==nil then
    return 0
  else
    return love.keyboard.isDown("space")
  end
end

function keyp(b)
  return key(b)
end

function mouse()
  mx=love.mouse.getX()/love_scale-love_wo+0.5
  my=love.mouse.getY()/love_scale-love_ho+0.5
  md=love.mouse.isDown(1)
  return mx,my,md
end

function rect(x,y,w,h,c)
  setColour(c)
  love.graphics.rectangle("fill",x,y,w,h)
  love.graphics.setColor(255,255,255)
end

function rectb(x,y,w,h,c)
  setColour(c)
  love.graphics.rectangle("line",x,y,w,h)
  love.graphics.setColor(255,255,255)
end

function pix(x,y,c)
  setColour(c)
  love.graphics.rectangle("fill",x,y,1,1)
  love.graphics.setColor(255,255,255)
end

function line(x1,y1,x2,y2,c)
  setColour(c)
  love.graphics.line(x1,y1,x2,y2)
  love.graphics.setColor(255,255,255)
end

function circ(x,y,r,c)
  setColour(c)
  love.graphics.circle("fill",x,y,r,20)
  love.graphics.setColor(255,255,255)
end

function circb(x,y,r,c)
  setColour(c)
  love.graphics.circle("line",x,y,r,20)
  love.graphics.setColor(255,255,255)
end

function tri(x1,y1,x2,y2,x3,y3,c)
  setColour(c)
  love.graphics.polygon("fill",x1,y1,x2,y2,x3,y3)
  love.graphics.setColor(255,255,255)
end

function textri(x1,y1,x2,y2,x3,y3,u1,v1,u2,v2,u3,v3)
  love.graphics.polygon("fill",x1,y1,x2,y2,x3,y3)
end

function time()
  return love.timer.getTime()*1000
end

function pmem()
  return 0
end

function poke()
  return 0
end

function peek()
  return 0
end

function poke4()
  return 0
end

function peek4()
  return 0
end

function map(dx,dy,w,h,x,y)
  if dx==nil then dx=0 end
  if dy==nil then dy=0 end
  if w==nil then w=30 end
  if h==nil then h=17 end
  if x==nil then x=0 end
  if y==nil then y=0 end
  for mapx=dx,dx+w do
    for mapy=dy,dy+h do
      spr(mget(mapx,mapy),mapx*8,mapy*8,x,y)
    end
  end
end

function mset(x,y,tile)
  love_map[math.floor(x+1)][math.floor(y+1)]=tile
end

function mget(x,y)
  if love_map[math.floor(x+1)]~=nil then
    return love_map[math.floor(x+1)][math.floor(y+1)]
  end
end

function sfx()
  return 0
end

function music()
  return 0
end
